import { world } from '@minecraft/server';


const dropChances = {
    stardust: 0.01,
    bottleOfDestiny: 0.002,
};

const bonusChance = 0.10;
const itemLossChance = 0.05;

function randomChance(probability) {
    return Math.random() < probability;
}

world.afterEvents.entityHitEntity.subscribe((data) => {
    const { damagingEntity, hitEntity } = data;

    if (damagingEntity.typeId !== 'minecraft:player') return;

    const inventory = damagingEntity.getComponent('minecraft:inventory');
    if (!inventory) return;

    let hasLuckItem = false;

    for (let i = 0; i < inventory.container.size; i++) {
        const item = inventory.container.getItem(i);
        if (item && item.typeId === 'la:stardust_destiny_luck') {
            hasLuckItem = true;
            break;
        }
    }

    const stardustChance = dropChances.stardust + (hasLuckItem ? bonusChance : 0);
    const bottleChance = dropChances.bottleOfDestiny + (hasLuckItem ? bonusChance : 0);

    if (damagingEntity.typeId === 'minecraft:player' && hitEntity.typeId !== 'minecraft:player') {

        if (randomChance(stardustChance)) {
            damagingEntity.runCommand('give @s la:stardust');
        }
        if (randomChance(bottleChance)) {
            damagingEntity.runCommand('give @s la:bottle_of_destiny');
        }
    }

    if (hasLuckItem && randomChance(itemLossChance)) {
        damagingEntity.runCommand('tellraw @s {"rawtext":[{"text":"§cSeu tempo de sorte foi consumido!"}]}');
        const inventoryComponent = damagingEntity.getComponent('minecraft:inventory');
        for (let i = 0; i < inventoryComponent.container.size; i++) {
            const item = inventoryComponent.container.getItem(i);
            if (item && item.typeId === 'la:stardust_destiny_luck') {
                inventoryComponent.container.setItem(i, undefined);
                break;
            }
        }
    }
});