import { world, system } from "@minecraft/server";

const positiveCommands = [
    ["give @s netherite_ingot 5", "give @s diamond_block 2", "effect @s strength 2 120", "say Big Luck Guy!"],
    ["give @s nether_star 1", "effect @s regeneration 2 60", "say A Celestial Luck!"],
    ["give @s ancient_debris 3", "effect @s fire_resistance 1 120", "say The Hell is You Friend!"],
    ["xp 5000 @s", "say You Like XP?"],
    ["give @s elytra 1", "give @s fireworks 16 1", "say You Believe in Fly?"],
    ["effect @s speed 3 300", "say Run like the wind!"],
    ["give @s golden_apple 5", "say A golden treat for you!"],
    ["effect @s haste 2 300", "say Work faster!"],
    ["give @s diamond_sword 1", "say Ready for battle?"],
    ["give @s emerald_block 10", "say Wealth beyond measure!"],
    ["effect @s absorption 3 200", "say Extra protection!"],
    ["give @s enchanted_golden_apple 2", "say Divine blessings!"],
    ["effect @s jump_boost 3 200", "say Leap to the skies!"],
    ["effect @s water_breathing 1 600", "say Explore the oceans!"],
    ["give @s trident 1", "say Wield the power of the seas!"],
    ["effect @s night_vision 1 300", "say See in the dark!"],
    ["give @s beacon 1", "say A light in the dark!"],
    ["effect @s slow_falling 1 300", "say Descend with grace!"],
    ["give @s enchanted_book {StoredEnchantments:[{id:sharpness,lvl:5}]}", "say A book of great power!"],
    ["give @s shield 1", "say Defend yourself!"],
    ["effect @s luck 1 300", "say Fortune smiles upon you!"],
    ["xp 10000 @s", "say Massive XP boost!"],
    ["give @s blaze_rod 5", "say Fuel your fires!"],
    ["effect @s health_boost 2 300", "say Extra health granted!"],
    ["give @s dragon_head 1", "say Wear this with pride!"],
    ["effect @s fire_resistance 2 600", "say Immune to flames!"],
    ["give @s shulker_box 1", "say Portable storage acquired!"],
    ["effect @s saturation 1 300", "say Stay well-fed!"],
    ["give @s netherite_sword 1", "say Wield unmatched power!"],
    ["effect @s resistance 2 300", "say You're tougher now!"],
    ["give @s enchanted_golden_apple 3", "say Blessings of health!"],
    ["effect @s water_breathing 1 600", "say Dive deeper!"],
    ["give @s diamond_helmet 1", "say Crown yourself in strength!"],
    ["effect @s luck 3 300", "say Fortune favors you!"],
    ["give @s diamond_pickaxe 1", "say Mine like a pro!"],
    ["effect @s night_vision 1 600", "say Illuminate the darkness!"],
    ["give @s ender_pearl 16", "say Travel with ease!"],
    ["effect @s haste 3 300", "say Work faster than ever!"]
];

const neutralCommands = [
    ["summon warden ~ ~ ~", ...Array(2).fill("summon warden ~ ~ ~"), "say The Sculk invade!"],
    ["summon ghast ~ ~ ~", ...Array(99).fill("summon ghast ~ ~ ~"), "say A fire sky!"],
    ["execute at @s run fill ~-10 ~-10 ~-10 ~10 ~10 ~10 air", "say Hah, It's a prank!"],
    ["summon evoker ~ ~ ~", ...Array(199).fill("summon evoker ~ ~ ~"), "say The Magic Invades!"],
    ["summon wither ~ ~ ~", ...Array(2).fill("summon ghast ~ ~ ~"), "say The Devil Invades!"],
    ["execute at @s run summon lightning_bolt ~ ~ ~", ...Array(40).fill("execute at @s run summon lightning_bolt ~ ~ ~"), "say Zeus Hates You!"],
    ["effect @s slowness 2 120", "say You feel heavy..."],
    ["effect @s blindness 1 60", "say Darkness surrounds you..."],
    ["give @s cobblestone 64", "say Building materials incoming!"],
    ["effect @s nausea 1 100", "say Feeling dizzy?"],
    ["effect @s levitation 2 30", "say Up you go!"],
    ["effect @s weakness 1 200", "say You feel frail..."],
    ["tp @s ~ ~50 ~", "say Enjoy the view!"],
    ["summon vex ~ ~ ~", "say Mischievous spirits arrive!"],
    ["give @s pufferfish 1", "say Careful, it's spiky!"],
    ["effect @s resistance 1 150", "say Strengthened defenses!"],
    ["setblock ~ ~ ~ barrier", "say What's this?"],
    ["summon dolphin ~ ~ ~", "say A friendly companion!"],
    ["execute at @s run fill ~-5 ~-5 ~-5 ~5 ~5 ~5 stone", "say Building a cage!"],
    ["summon bee ~ ~ ~ {Anger:1b}", "say Don't make it mad!"],
    ["execute at @s run fill ~-3 ~-3 ~-3 ~3 ~3 ~3 water", "say A pool just for you!"],
    ["summon skeleton ~ ~ ~", "say Skeleton inbound!"],
    ["effect @s invisibility 1 200", "say Now you see me, now you don't!"],
    ["give @s torch 64", "say Light up your path!"],
    ["summon iron_golem ~ ~ ~", "say A protector appears!"],
    ["execute at @s run fill ~-3 ~-3 ~-3 ~3 ~3 ~3 lava", "say A fiery cage!"],
    ["effect @s slow_falling 1 200", "say Float gently!"],
    ["give @s obsidian 10", "say Ready for a portal?"],
    ["tp @s ~100 ~ ~", "say A quick trip forward!"],
    ["summon panda ~ ~ ~", "say A peaceful companion!"],
    ["effect @s speed 2 300", "say Quick as a flash!"]
];

const negativeCommands = [
    ["execute at @s run kill @e[r=150]", "say Death penalty!"],
    ["summon warden ~ ~ ~", ...Array(50).fill("summon warden ~ ~ ~"), "say Oh, Sorry, the creator is CrAZy!"],
    ["summon creeper ~ ~ ~", ...Array(99).fill("summon creeper ~ ~ ~"), "say Explosion!"],
    ["summon lightning_bolt ~ ~ ~", ...Array(499).fill("summon lightning_bolt ~ ~ ~"), "say Zeus Really Hates You!"],
    ["tp @s 1000000 100 1000000", "say What is here?"],
    ["effect @s wither 255 9999 true", "effect @s hunger 255 9999 true", "say You are so weak!"],
    ["effect @s poison 255 9999", "say Painful, isn't it?"],
    ["summon wither ~ ~ ~", "say A true nightmare arrives!"],
    ["effect @s mining_fatigue 255 300", "say You can't even break a block!"],
    ["clear @s", "say Your inventory is gone!"],
    ["effect @s slowness 255 300", "say You are stuck!"],
    ["tp @s 0 -64 0", "say Welcome to the void!"],
    ["effect @s blindness 255 300", "say You can't see!"],
    ["give @s dirt 1", "say Enjoy your reward!"],
    ["effect @s nausea 255 300", "say The world spins around you!"],
    ["execute at @s run summon zombie ~ ~ ~", "say A horde approaches!"],
    ["summon fireball ~ ~ ~ {direction:[0.0,0.0,0.0]}", "say Watch out!"],
    ["effect @s weakness 255 300", "say You're powerless!"],
    ["effect @s levitation 255 50", "say Ascend to your doom!"],
    ["execute at @s run summon endermite ~ ~ ~", "say Creepy crawlies!"],
    ["effect @s instant_damage 2 1", "say Feel the pain!"],
    ["summon enderman ~ ~ ~", "say Watch your gaze!"],
    ["effect @s blindness 2 300", "say The darkness consumes you!"],
    ["summon phantom ~ ~ ~", "say Nightmares descend!"],
    ["execute at @s run summon lightning_bolt ~ ~ ~", "say Struck by the heavens!"],
    ["effect @s nausea 2 200", "say The world spins endlessly!"],
    ["summon creeper ~ ~ ~", "say Beware the explosion!"],
    ["clear @s", "say Your items vanish!"],
    ["effect @s wither 2 300", "say Decay overwhelms you!"]
];

function executeRandomCommand(player, commandList) {
    const randomSet = commandList[Math.floor(Math.random() * commandList.length)];
    randomSet.forEach(command => {
        player.runCommand(command);
    });
}

system.runInterval(() => {
    const players = world.getPlayers();

    players.forEach(player => {

        if (player.hasTag("random")) {

            const randomChoice = Math.random();
            if (randomChoice < 0.5) {

                executeRandomCommand(player, positiveCommands);
            } else if (randomChoice < 0.7) {

                executeRandomCommand(player, neutralCommands);
            } else {

                executeRandomCommand(player, negativeCommands);
            }

            player.runCommand("tag @s remove random");
        }
    });
}, 15);